# Python imports

# Lib imports
import gi
gi.require_version('Gtk', '3.0')
from gi.repository import Gtk

# Application imports



class InfoLinkButton(Gtk.LinkButton):
    def __init__(self, title: str = "[NO INFO TITLE PASSED]",
                        info_link: str or None = None):
        super(InfoLinkButton, self).__init__()

        info_link_title  = f"{title} LSP Info" if info_link else "Generic LSP Info"
        info_link        = info_link if info_link else "https://microsoft.github.io/language-server-protocol/specifications/lsp/3.17/specification/#contentPart"

        self.set_label(info_link_title)
        self.set_uri(info_link)

        self._setup_styling()
        self._setup_signals()
        self._subscribe_to_events()
        self._load_widgets()

        self.show_all()


    def _setup_styling(self):
        ctx = self.get_style_context()
        ctx.add_class("info-link-button")

    def _setup_signals(self):
        ...

    def _subscribe_to_events(self):
        ...

    def _load_widgets(self):
        ...
